
import Globals
from OFS.SimpleItem import SimpleItem

def initialize(context):
    context.registerClass(Symlink,
                          constructors=(manage_addSymlinkForm,
                                        manage_addSymlink))

manage_addSymlinkForm = Globals.HTMLFile('addSymlinkForm', globals())

def manage_addSymlink(self, path, REQUEST=None):
    '''Finds the linked object to get its ID, then adds a symlink
    that points to it.
    '''
    ob = self.restrictedTraverse(path)
    id = ob.id
    if callable(id):
        try: id = id()
        except: pass
    link = Symlink(id, path)
    self._setObject(id, link)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


class Symlink(SimpleItem):
    meta_type = 'Symlink'

    _v_recursion = 100
    
    def __init__(self, id, path):
        self.id = id
        self.path = path

    def __of__(self, parent):
        try:
            r = self._v_recursion
            if r < 0:
                raise SystemError('Excessive recursion')
            self._v_recursion = r - 1
            ob = parent.restrictedTraverse(self.path)
        except:
            del self._v_recursion
            import traceback
            traceback.print_exc()
            # Store symlink failure info in _v_error here.
            return self
        else:
            v = ob.__of__(parent)
            del self._v_recursion
            return v

Globals.default__class_init__(Symlink)
